/*- LlamaChat.java ------------------------------------------------+
 |                                                                 |
 |  Copyright (C) 2002-2003 Joseph Monti, LlamaChat                |
 |                     countjoe@users.sourceforge.net              |
 |                     http://www.42llamas.com/LlamaChat/          |
 |                                                                 |
 | This program is free software; you can redistribute it and/or   |
 | modify it under the terms of the GNU General Public License     |
 | as published by the Free Software Foundation; either version 2  |
 | of the License, or (at your option) any later version           |
 |                                                                 |
 | This program is distributed in the hope that it will be useful, |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of  |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   |
 | GNU General Public License for more details.                    |
 |                                                                 |
 | A copy of the GNU General Public License may be found in the    |
 | installation directory named "GNUGPL.txt"                       |
 |                                                                 |
 +-----------------------------------------------------------------+
 */

package client;

import java.awt.*;
import java.awt.List;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.*;
import java.lang.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.nio.CharBuffer;
import java.util.regex.Pattern;
import java.util.Properties;

import common.*;
import common.sd.*;
import client.XMLReader;

import java.io.*;
import java.net.*;

import java.net.URL;

import javax.swing.JPanel;

//import org.xml.sax.XMLReader;


public class EEGLABChat extends JPanel implements ActionListener
{
	
	public String username = null;
	private ServerConnection server;
	public int PORT;
	public String site;
	public ArrayList users;
	private CommandHistory history;
	public ArrayList ignores;
	public ArrayList afks;
	public ArrayList admins;
	public boolean admin;
	public String locationURL;
	public Hashtable channels;
	private static final String VERSION = "v0.8";
	public PrivateMsg privates;
	public boolean showUserStatus;
	public boolean chanAdmin;
	public boolean isNameParsed= false;
	public URL classLocation;
	public int m_nUsers; //the number of users online now
	private String m_lastMsg;
	private int m_textFontSize=2;
	
	
	//==YI==
	//--Customized UI params--
	private double headlineHeightRatio = 0.1;
	private double textScrollerWidthRatio = 0.79;
	private double textScrollerHeightRatio = 0.69;
	private double messageAreaWidthRatio = 0.98;
	private double messageAreaHeightRatio = 0.15;
	private double heightBtwMsgTextScrollRatio = 0.06;
	private double bottomlineHeightRatio = 0.01;//not used
	private double sideborderRatio = 0.01;
	private double userlistHeightRatio = 0.69;
	private double userlistWidthRatio = 0.19;
	
	
	Container c;
	
	ChatPane mainChat;
	JList userList;
	JTextField messageText;
	JTextArea messageArea;
	JScrollPane textScroller;
	JScrollPane userScroller;
	JPopupMenu popup;
	//JComboBox cboChannels;
	//JButton butChannel;
	//JButton butCreate;
	
	ImageIcon conNo;
	ImageIcon conYes;
	ImageIcon secNo;
	ImageIcon secYes;
	ImageIcon conSccn;
	ImageIcon conFontEnlarge;
	ImageIcon conFontReduce;
	JLabel conIcon;
	JLabel secIcon;
	JButton fontEnlargeIcon;
	JButton fontReduceIcon;
	JLabel sccnIcon;
	JLabel bottomText;
	JLabel topText;
	JLabel promptLabel;
	
	
	MyAction myAction;
	MyKeyListener myKeyListener;
	MyMouseListener myMouseListener;
	MyHyperlinkListener myHyperlinkListener;
	Color myColors[] = new Color[3];
	
	Rectangle rect;

	public void getClassLocation()
	{
	    final String cLocation = EEGLABChat.class.getName().replace('.', '/') 
	              + ".class";
	    final ClassLoader loader = EEGLABChat.class.getClassLoader();
	    if (loader == null) {
	     System.out.println("Cannot load the class");
	   } else {
	      classLocation = loader.getResource(cLocation);
	    }
	}
	public void getClassLocationBase()
	{
	    final String cLocation = EEGLABChat.class.getName().replace('.', '/') 
	              + ".class";
	    final ClassLoader loader = EEGLABChat.class.getClassLoader();
	    if (loader == null) {
	     System.out.println("Cannot load the class");
	   } else {
	      classLocation = loader.getResource("images");
	    }
	}
	
	@Override protected void paintComponent(Graphics g)
	{
		//System.out.print("I'm painted");
		int width = this.getWidth();
		int height = this.getHeight();
		int borderWidth = (int)((int)width * sideborderRatio);
		int borderHeight = (int)((int)height * sideborderRatio);
		int headlineHeight = (int)((int)height * headlineHeightRatio);
		int heightBtwMsgTextScroll = (int)((int)height * heightBtwMsgTextScrollRatio);
		textScroller.setBounds(borderWidth,headlineHeight, (int)((int)width*textScrollerWidthRatio),(int)((int)height*textScrollerHeightRatio));
		messageArea.setBounds(borderWidth,headlineHeight + textScroller.getHeight()+heightBtwMsgTextScroll,(int)((int)width*messageAreaWidthRatio),(int)((int)height*messageAreaHeightRatio));
		userScroller.setBounds(borderWidth+textScroller.getWidth(), headlineHeight,(int)((int)width*userlistWidthRatio),(int)((int)height*userlistHeightRatio));
		sccnIcon.setBounds((int)((int)width/2)-90,(int)((int)height*headlineHeightRatio/2)-15,30,30);
		topText.setBounds(sccnIcon.getX()+30, (int)((int)height*headlineHeightRatio/2)-15, 150, 30);
		promptLabel.setBounds(borderWidth,messageArea.getY()-12,200,12);
		fontEnlargeIcon.setBounds(userScroller.getX(),userScroller.getY()+userScroller.getHeight(),22,22);
		fontReduceIcon.setBounds(userScroller.getX()+22, userScroller.getY()+userScroller.getHeight(), 22, 22);
		
	}
	
	public void redraw()
	{
		this.show();
	}
	
	public String getGeoLocation(String ip)
	{
		try {
		    // Construct data
		    String data = URLEncoder.encode("ip", "UTF-8") + "=" + URLEncoder.encode(ip, "UTF-8");

		    // Send data
		    URL url = new URL("http://api.ipinfodb.com/v3/ip-city/?key=ce092ebcf84ba8905fc30c0c560856835022077f798a5e99ab4dcd05ecdc67f8");
		    URLConnection conn = url.openConnection();
		    conn.setDoOutput(true);
		    OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
		    wr.write(data);
		    wr.flush();

		    // Get the response
		    BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		    String line;
		    String total="";
		    while ((line = rd.readLine()) != null) {
		        // Process line...
		    	//System.out.println(line);
		    	total += line;
		    }
		    String[] tmpString = total.split(";");
		    
		    String cityName = tmpString[6];
		    cityName = cityName.replace(' ', '_');
		    wr.close();
		    rd.close();
		    return cityName;
		} catch (Exception e) {
			return "";
		}
	}
	
	public EEGLABChat(String ip)
	{
		site = ip;
		
	}
	
	/**
	 * Initializes the graphical components
	 */
	public void init() {
		
		int width = this.getWidth();
		int height = this.getHeight();
		int borderWidth = (int)((int)width * sideborderRatio);
		int headlineHeight = (int)((int)height * headlineHeightRatio);
		int heightBtwMsgTextScroll = (int)((int)height * heightBtwMsgTextScrollRatio);
//		XMLReader reader = new XMLReader();
		
		getClassLocation();
		//username = getParameter("username");
		if (username == null) {
//			username = JOptionPane.showInputDialog(
//									this,
//									"Please enter a username",
//									"Login",
//									JOptionPane.QUESTION_MESSAGE);
//			System.out.println("Username set to " + username);
		    try 
		    {
		        InetAddress thisIp =
		           InetAddress.getLocalHost();
		        System.out.println(thisIp.getHostAddress());
//		        username = null;
				if((username=readUsernameLog())==null)
		        {
					username = getGeoLocation(thisIp.getHostAddress());
					System.out.println("Geo User Name " + username);
					isNameParsed = false;
		        }
				else
				{
					isNameParsed = true;
				}
		        //System.out.println("IP:"+thisIp.getHostAddress());
		    }
		    catch(Exception e) {
		        e.printStackTrace();
		    }
		}
		try {
//			PORT = Integer.valueOf(reader.GetPort()).intValue();
			PORT = 42412;
		} catch (NumberFormatException e) {
			PORT = 42412;
		}
		
		//URL url = getDocumentBase();
//		PORT = 42412;
		//site = "127.0.0.1";//url.getHost();
		locationURL = site + ":" + PORT + "/";// + url.getPath();
		System.out.println("Connection to " + locationURL);
		
		setSize(315,365);
		c = this;
		
		//c.setBackground(new Color(237,244,255));
		c.setBackground(new Color(255,255,255));
		
		if (site == null || locationURL == null) {
			c.add(new JLabel("ERROR: did not recieve needed data from page"));
		}

		myAction = new MyAction();
		myKeyListener = new MyKeyListener();
		myMouseListener = new MyMouseListener();
		myHyperlinkListener = new MyHyperlinkListener();

		c.setLayout(null);
		
		/*cboChannels = new JComboBox();
		cboChannels.setBounds(5, 5, 150, 24);
		
		butChannel = new JButton("Join");
		butChannel.setToolTipText("Join channel");
		butChannel.addActionListener(myAction);
		butChannel.setBounds(160, 5, 60, 24);
		
		butCreate = new JButton("Create");
		butCreate.setToolTipText("Create new channel");
		butCreate.addActionListener(myAction);
		butCreate.setBounds(230, 5, 80, 24);
		butCreate.setEnabled(false);*/
		
		mainChat = new ChatPane(this);
		textScroller = new JScrollPane(mainChat, 
								JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
								JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		//textScroller.setBounds(5,34,(int)(width*0.5),(int)(height*0.7));
		textScroller.setBounds(borderWidth,headlineHeight, (int)((int)width*textScrollerWidthRatio),(int)((int)height*textScrollerHeightRatio));
		Font font = new Font("TimesRoman", Font.ITALIC,  50);
		mainChat.setFont(font);
				
		userList = new JList();
		userList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		userList.setCellRenderer(new MyCellRenderer());
		userList.setBackground(new Color(249, 249, 250));
		userScroller = new JScrollPane(userList);
		userScroller.setBounds(borderWidth+textScroller.getWidth(), headlineHeight,(int)((int)width*userlistWidthRatio),(int)((int)height*userlistHeightRatio));
		
		messageText = new JTextField();
		messageText.setBounds(5,319,300,22);
		messageText.setColumns(10);
		messageText.setBackground(new Color(249, 249, 250));
		
		//==Yi==
		messageArea = new JTextArea();
		messageArea.setBounds(borderWidth,headlineHeight + textScroller.getHeight()+heightBtwMsgTextScroll,(int)((int)width*messageAreaWidthRatio),(int)((int)height*messageAreaHeightRatio));
		messageArea.setColumns(10);
		messageArea.setRows(2);
		messageArea.setBackground(new Color(249,249,250));
		//This creates a nice frame.
		Border loweredetched;
		loweredetched = BorderFactory.createEtchedBorder(EtchedBorder.LOWERED);
		messageArea.setBorder(loweredetched);
		
		JMenuItem item;
		popup = new JPopupMenu("test");
		popup.add("whisper").addActionListener(myAction);
		popup.add("private message").addActionListener(myAction);
		popup.add("ignore").addActionListener(myAction);
		popup.add("clear ignore list").addActionListener(myAction);
		
		conNo = new ImageIcon(getURL("images/connect_no.gif"));
		conYes = new ImageIcon(getURL("images/connect_established.gif"));
		secNo = new ImageIcon(getURL("images/decrypted.gif"));
		secYes = new ImageIcon(getURL("images/encrypted.gif"));
		conSccn = new ImageIcon(getURL("images/SCCN.gif"));
		conFontEnlarge = new ImageIcon(getURL("images/MagnifyPlus.gif"));
		conFontReduce = new ImageIcon(getURL("images/MagnifyMinus.gif"));
		
		conIcon = new JLabel(conNo);
		conIcon.setBorder(new EtchedBorder());
		secIcon = new JLabel(secNo);
		secIcon.setBorder(new EtchedBorder());
		sccnIcon = new JLabel(conSccn);
		sccnIcon.setBorder(new EtchedBorder());
		fontEnlargeIcon = new JButton(conFontEnlarge);
		fontReduceIcon = new JButton(conFontReduce);
		fontEnlargeIcon.addActionListener(this);
		fontEnlargeIcon.setActionCommand("Enlarge");
		fontReduceIcon.addActionListener(this);
		fontReduceIcon.setActionCommand("Reduce");

		conIcon.setBounds(563,334, 22, 22);
		secIcon.setBounds(588,334, 22, 22);
		sccnIcon.setBounds((int)((int)width/2)-90,(int)((int)height*headlineHeightRatio/2)-15,30,30);
		fontEnlargeIcon.setBounds(userScroller.getX(),userScroller.getY()+userScroller.getHeight(),22,22);
		fontReduceIcon.setBounds(userScroller.getX()+22, userScroller.getY()+userScroller.getHeight(), 22, 22);
		
		/*bottomText = new JLabel("<html><body><font color=#445577><b>" +
						"LlamaChat " + VERSION + "</b></font> &nbsp;&copy; " +
						"<a href=\"" + linkURL+ "\">Joseph Monti</a> 2002-2003" +
						"</body></html>");*/
		
		//==Yi==
		topText = new JLabel("<html><body><font color=#445577><b>" +
				"EEGLAB Chat" + "</b></font> &nbsp; " +
				"<a href=\"" + "http://sccn.ucsd.edu/eeglab/"+ "\"></a>" +
				"</body></html>");
		topText.setBounds(sccnIcon.getX()+30, (int)((int)height*headlineHeightRatio/2)-15, 150, 30);
		
		bottomText = new JLabel("<html><body><font color=#FF0000 size=2><b>" +
				"online users" + "</b></font>" +"</body></html>");
		bottomText.setBounds(220, 365, 100, 20);
		
		//==Yi==
		promptLabel = new JLabel("<html><body><font color=#445588 size=1><b>" +
				"Type here:" + "</b></font></body></html>");
		promptLabel.setBounds(borderWidth,messageArea.getY()-12,200,12);
		
		//c.add(cboChannels);
		//c.add(butChannel);
		//c.add(butCreate);
		c.add(textScroller);
		c.add(userScroller);
		c.add(messageArea);
		//c.add(conIcon);
		//c.add(secIcon);
		c.add(topText);
		//c.add(bottomText);
		c.add(promptLabel);
		c.add(sccnIcon);
		c.add(fontEnlargeIcon);
		c.add(fontReduceIcon);
		userList.addMouseListener(myMouseListener);
		messageArea.addKeyListener(myKeyListener);
		messageText.addKeyListener(myKeyListener);
		bottomText.addMouseListener(myMouseListener);
		
		users = new ArrayList();
		ignores = new ArrayList(5);
		ignores.add("server");
		afks = new ArrayList(5);
		admins = new ArrayList(5);
		history = new CommandHistory(10);
		admin = false;
		channels = new Hashtable();
		privates = new PrivateMsg(this, m_textFontSize);
		showUserStatus = false;
		
		myColors[0] = new Color(200, 0, 0);
		myColors[1] = new Color(0, 150, 0);
		myColors[2] = new Color(0, 0, 200);
		
		rect = new Rectangle(0,0,1,1);

		// validate the name
		if (!username.matches("[\\w_-]+?")) {
			error("username contains invalid characters, changing to " +
						"'invalid' for now. " +
						"Type \\rename to chose a new name");
			username = "invalid";
		}
		if (username.length() > 10) {
			username = username.substring(0,10);
			error("username too long, changed to " + username);
		}

		connect();
		/*String opening = 
			"<font color=#333333>" +
						 "==================================<br>" +
						 "Welcome to EEGLAB Chat Room"+"<br>" +
						 "If you need assistance, type \\help<br>" +
						 "Enjoy your stay!<br>" +
						 "==================================<br></font>";
		HTMLDocument doc = (HTMLDocument) mainChat.getDocument();
		HTMLEditorKit kit = (HTMLEditorKit) mainChat.getEditorKit();
		try {
			kit.insertHTML(doc,doc.getLength(),opening,0,0,HTML.Tag.FONT);
		} catch (Throwable t) { t.printStackTrace(System.out); }
		*/
	}
	
	//==Set User name==
	public void writeUsernameLog(String username)
	{
		try
		{
			String userDir = System.getProperty("user.home");
			// Create file 
			FileWriter fstream = new FileWriter(userDir+"/EEGLabRoomLog");
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(username);
			//Close the output stream
			out.close();
		}
		catch (Exception e)
		{
		  //Catch exception if any
		  System.err.println("Error: " + e.getMessage());
		}
	}
	public String readUsernameLog()
	{
		String username = null;
		try
		{
			String userDir = System.getProperty("user.home");
			// Create file 
			File log = new File(userDir+"/EEGLabRoomLog");
			if(log.exists())
			{
				FileReader fstream = new FileReader(userDir+"/EEGLabRoomLog");
				BufferedReader in = new BufferedReader(fstream);
				username = in.readLine();
				//Close the output stream
				in.close();
			}
		}
		catch (Exception e)
		{
		  //Catch exception if any
		  System.err.println("Error: " + e.getMessage());
		}
		return username;
	}
	
	public void start() { }
	
	public void stop() {
		if (server != null)
			server._writeObject(new SD_UserDel(null)); // to bypass the queue
	}
	
	/**
	 * Subclass to act as the action listener for graphical components
	 */
	protected final class MyAction implements ActionListener {
		public void actionPerformed(ActionEvent ae) {
			String cmd = ae.getActionCommand().intern();
			/*if (ae.getSource() == butChannel) {
				String pass = null;
				String channel = (String) cboChannels.getSelectedItem();
				if (channels.containsKey(channel) && ((Boolean) channels.get(channel)).booleanValue()) {
					String message = "Password for " +  channel + 
									"? (blank for no password)";
					pass = JOptionPane.showInputDialog(
									(Component) ae.getSource(),
									message,
									"Join Channel",
									JOptionPane.QUESTION_MESSAGE);
				}
				server.writeObject(new SD_Channel(false, channel, 
							("".equals(pass) ? null : pass)));
				showUserStatus = false;
			}/* else if (ae.getSource() == butCreate) {
				String channel = JOptionPane.showInputDialog(
									(Component) ae.getSource(),
									"Enter the name of the channel",
									"Create Channel",
									JOptionPane.INFORMATION_MESSAGE);
				if (channel == null) return;
				String message = "Password for " +  channel + 
									"? (blank for no password)";
				String pass = JOptionPane.showInputDialog(
									(Component) ae.getSource(),
									message,
									"Join Channel",
									JOptionPane.QUESTION_MESSAGE);
				server.writeObject(new SD_Channel(true, channel, 
									("".equals(pass) ? null : pass)));
				showUserStatus = false;
			}else*/ if (cmd == "whisper") {
				String user = (String)userList.getSelectedValue();
				if (user != null && !messageArea.getText().equals("") && 
													!user.equals(username)) {
					messageArea.setText("\\whisper " + user + " " + 
													messageArea.getText());
					sendMessage();
				} else {
					error("invalid user or no message, type a message below," +
							" select a user, and then whisper");
				}
			} else if (cmd == "private message") {
				String user = (String)userList.getSelectedValue();
				if (user != null && !user.equals(username)) {
					privates.newPrivate(user);
				} else {
					error("invalid user");
				}
			} else if (ae.getActionCommand().equals("ignore")) {
				String user = (String)userList.getSelectedValue();
				if (user != null) {
					ignore(user, false);
				} else {
					error("no user selected");
				}
			} else if (cmd == "clear ignore list") {
				ignores.clear();
				updateList();
				serverMessage("ignore list cleared");
			} else if (cmd == "kick user") {
				String user = (String)userList.getSelectedValue();
				if (user != null) {
					if (user.equals(username)) {
						error("cannot kick yourself");
					} else {
						server.writeObject(new SD_Kick(user));
					}
				} else {
					error("no user selected");
				}
			}
		}
	}
	
	/**
	 * Subclass to act as the key listener for the graphical componets
	 */
	protected final class MyKeyListener implements KeyListener {
		public void keyTyped(KeyEvent ke) {
			if (ke.getKeyChar() == KeyEvent.VK_ENTER) {
				sendMessage();
			}
		}
		public void keyPressed(KeyEvent ke) {
			//
		}
		public void keyReleased(KeyEvent ke) {
			if (ke.getKeyCode() == KeyEvent.VK_UP) {
				String up = history.getUp();
				if (up != null)
					messageArea.setText(up);
			} else if (ke.getKeyCode() == KeyEvent.VK_DOWN) {
				String down = history.getDown();
				if (down != null)
					messageArea.setText(down);
			}
		}
	}
	
	/**
	 * Subclass to act as the mouse listener for the graphical components
	 */
    protected final class MyMouseListener implements MouseListener {
        public void mousePressed(MouseEvent e) {
        }

        public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
        }
    
    	public void mouseEntered(MouseEvent e) {
    		if (e.getSource() == bottomText) {
    			bottomText.setCursor(
						Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    		}
    	}
    	public void mouseExited(MouseEvent e) {
    		if (e.getSource() == bottomText) {
    			bottomText.setCursor(Cursor.getDefaultCursor());
    		}
    	}
    
    	public void mouseClicked(MouseEvent e) {
        	/*if (e.getSource() == bottomText) {
				try {
					/*getAppletContext().showDocument(
										new URL(linkURL), "_blank");
        		} catch (java.net.MalformedURLException ex) { }
        	} else {
            	maybeShowPopup(e);
			}*/
		}    		

		/**
		 * Checks to see if the event was to show the popup menu
		 */
        private void maybeShowPopup(MouseEvent e) {
            if ((e.getModifiers() & MouseEvent.BUTTON3_MASK)!=0) {
                popup.show(userList, e.getX(), e.getY());
            }
        }
    }
	
	protected final class MyHyperlinkListener implements HyperlinkListener {
		public void hyperlinkUpdate(HyperlinkEvent e) {
			/*if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
				getAppletContext().showDocument(e.getURL(), "_blank");
			}*/
		}
	}
	
	/**
	 * a Subclass to handle cell items in the user list
	 * lets us modify add an icon to the username
	 */
	protected final class MyCellRenderer extends DefaultListCellRenderer {
		final ImageIcon normal = 
					new ImageIcon(getURL("images/face.gif"));
		final ImageIcon ignored = 
					new ImageIcon(getURL("images/face_ignore.gif"));
		final ImageIcon afk = 
					new ImageIcon(getURL("images/afk.gif"));
		final ImageIcon admin =
					new ImageIcon(getURL("images/admin.gif"));

		/* This is the only method defined by ListCellRenderer.  We just
		* reconfigure the Jlabel each time we're called.
		*/
		public Component getListCellRendererComponent(
					JList list,
					Object value,   // value to display
					int index,      // cell index
					boolean iss,    // is the cell selected
					boolean chf)    // the list and the cell have the focus
		{
			/* The DefaultListCellRenderer class will take care of
			* the JLabels text property, it's foreground and background
			* colors, and so on.
			*/
			super.getListCellRendererComponent(list, value, index, iss, chf);
			if (afks.contains(value.toString())) {
				setIcon(afk);
			} else if (admins.contains(value.toString())) {
				setIcon(admin);
			} else if (ignores.contains(value.toString())) {
				setIcon(ignored);
			} else {
				setIcon(normal);
			}
			if (username.equals(getText())) {
				setForeground(myColors[1]);
			} else {
				setForeground(myColors[2]);
			}

			return this;
		}
	}
	
	/**
	 * Method to take a filename and return a URL object
	 * @param filename	the name of the file to be turned into URL
	 * @return the url representing filename
	 */
    protected final URL getURL(String filename) {
        URL url = null;
        String executionPath = System.getProperty("user.dir");
        url = this.getClass().getResource("/images");
        //String location = "/images/";//getCodeBase();
        //String protocal = "file:///";
       /* try {
            //url = new URL(protocal + executionPath + "/" + filename);//new URL(locationURL + filename);
        	 
        } catch (java.net.MalformedURLException e) {
            System.err.println("Couldn't create image: " +
                               "badly specified URL");
            return null;
        }*/
        System.out.println(this.getClass().getName());
        url = this.getClass().getResource("/"+filename);
    
        return url;
    }

	/**
	 * Method called when a user message has been sent.
	 * checks to see if it is a command or regular message
	 */
	private void sendMessage() {
		String txt = new String(messageArea.getText());
		if (!txt.equals("")) {
			if (txt.charAt(0) == '\\' || txt.charAt(0) == '/') {
				parseCommand(txt.substring(1));
				messageArea.setText("");
				history.add(txt);
			} else if (server != null && server.connected && username != null) {
				sendText(username, txt, false);
				messageArea.setText("");
				sendChat(txt);
				history.add(txt);
			} else {
				error("Not connected, type \\reconnect to try and reconnect");
			}
		}
		messageArea.setCaretPosition(0);
	}
	
	/**
	 * Method to parse a command and perform the specified action
	 * @param cmd	the command that the user typed
	 * @return a status indicator to tell if the command was valid
	 */
	public boolean parseCommand(String cmd) {
		cmd = cmd.intern();
		if (cmd == "help" || cmd == "?") {
			String commands = "Listing  available commands:\n" + 
					"<pre>\\help or \\? \t\t- display this message<br>" +
					"\\admin &lt;passphrase&gt; \t- become an admin<br>" + 
					"\\create &lt;channel&gt; [password]\t- create a new channel with optional password<br>" +
					"\\join &lt;channel&gt;  [password]\t- join channel with optional password<br>" +
					"\\disconnect \t\t- disconnect from server<br>" +
					"\\whisper &lt;user&gt; &lt;message&gt; \t- whisper to a user<br>" + 
					"\\private &lt;user&gt; \t- start a private message session<br>" +
					"\\ignore &lt;user&gt; \t\t- ignores a user<br>" +
					"\\clearignore \t\t- clear list of ignores<br>" +
					"\\reconnect \t\t- attempt to reconnect to server<br>" +
					"\\rename &lt;new name&gt; \t\t- change your username<br>";
			if (admin) {
				commands += "\\kick &lt;user&gt; \t\t- kick user from room<br>" + 
							"\\logstart \t\t- start logging sessoin<br>" + 
							"\\logstop \t\t- stop logging session<br>";
			}
			commands += "up or down \t\t- cycle your chat history</pre>";
			sendText("server", commands, false);
			return true;
		} else if (cmd == "disconnect") {
			if (server != null) {
				stop();
			}
			return true;
		} else if (cmd == "reconnect") {
			if (username == null) {
				error("username still invalid. use \\rename &lt;new name&gt; to chose a new name and reconnect");
			} else {
				if (server != null) {
					stop();
				}
				server = new ServerConnection(this);
			}
			return true;
		} else if (cmd == "clearignore") {
			ignores.clear();
			updateList();
			serverMessage("ignore list cleared");
			return true;
		} else if (cmd.startsWith("whisper")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\whisper &lt;user&gt; &lt;message&gt;");
				return false;
			}
			cmd = cmd.substring(start+1);
			start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\whisper &lt;user&gt; &lt;message&gt;");
				return false;
			}
			String un = cmd.substring(0, start);
			if (username.equals(un) || !users.contains(un)) {
				error("invalid user");
				return false;
			}
			String message = cmd.substring(start+1);
			if (message.length() < 1) {
				error("usage: \\whisper &lt;user&gt; &lt;message&gt;");
			}
			sendWhisper(un, message);
			sendText(username, message, true);
			return true;
		} else if (cmd.startsWith("private")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\private &lt;user&gt;");
				return false;
			}
			String un = cmd.substring(start+1);
			if (username.equals(un)) {
				error("cannot private message yourself");
				return false;
			}
			privates.newPrivate(un);
			return true;
		} else if (cmd.startsWith("rename")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\rename &lt;newname&gt;");
				return false;
			}
			String newName = cmd.substring(start+1);
			if ((newName.length() < 1) || (newName.length()) > 10 || 
											(newName.equals("server")) ||
											(!newName.matches("[\\w_-]+?"))) {
				error("invalid name");
				return false;
			}
			if (!server.connected) {
				server = new ServerConnection(this);
			}
			if (username == null) {
				username = newName;
				server.writeObject(new SD_UserAdd(newName,false));
			} else {
				rename(username, newName);
				String on = username;
				username = newName;
				server.writeObject(new SD_Rename(on, username));
			}
			return true;
		} else if (cmd.startsWith("ignore")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\ignre &lt;user&gt;");
				return false;
			}
			ignore(cmd.substring(start+1), false);
			return true;
		} else if (cmd.startsWith("join")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\join &lt;channel&gt; [password]");
				return false;
			}
			String name = cmd.substring(start+1);
			String pass = null;
			start = name.indexOf(' ');
			if (start > 0) {
				pass = name.substring(start+1);
				name = name.substring(0, start);
			}
			server.writeObject(new SD_Channel(false, name, pass));
			return true;
		} else if (cmd.startsWith("create")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\create &lt;channel&gt; [password]");
				return false;
			}
			String name = cmd.substring(start+1);
			String pass = null;
			start = name.indexOf(' ');
			if (start > 0) {
				pass = name.substring(start+1);
				name = name.substring(0, start);
			}
			server.writeObject(new SD_Channel(true, name, pass));
			return true;
/*		} else if (cmd.startsWith("proxy")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\proxy &lt;host&gt; &lt;port&gt;");
				return false;
			}
			String phost = cmd.substring(start+1);
			start = phost.indexOf(' ');
			if (start < 0) {
				error("usage: \\proxy &lt;host&gt; &lt;port&gt;");
				return false;
			}
			String pport = phost.substring(start+1);
			phost = phost.substring(0, start);
			Properties systemSettings = System.getProperties();
			systemSettings.put("proxySet", "true");
			systemSettings.put("proxyHost", phost);
			systemSettings.put("proxyPort", pport);
			System.setProperties(systemSettings);
			serverMessage("Using " + phost + ":" + pport + " as proxy server<br>you can type \\reconnect to reconnect with this proxy");
			return true; */
		}else if (cmd.startsWith("admin")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\admin &lt;password&gt;");
				return false;
			}
			String pass = cmd.substring(start+1);
			server.writeObject(new SD_AdminAdd(pass));
			return true;
		} else if (admin && cmd.startsWith("kick")) {
			int start = cmd.indexOf(' ');
			if (start < 0) {
				error("usage: \\kick &lt;user&gt;");
				return false;
			}
			String un = cmd.substring(start+1);
			if (un.equals(username)) {
				error("cannot kick yourself");
				return false;
			}
			server.writeObject(new SD_Kick(un));
			return true;
		} else if (admin && cmd == "logstart") {
			server.writeObject(new SD_Log(true));
			return true;	
		} else if (admin && cmd == "logstop") {
			server.writeObject(new SD_Log());
			return true;
		}
		error("unrecognized command, type \\help for help");
		return false;
	}
	
	/**
	 * Method to ignore all incoming messages from a user
	 * @param i		the user to ignore
	 * @param quite	if true will not show confirmation
	 * @return true on succes, false on failure
	 */
	private boolean ignore(String i, boolean quiet) {
		if (username.equals(i) || i.equals("server") || admins.contains(i)) {
			if (!quiet) {
				error("can't ignore that person");
			}
			return false;
		}
		if (!users.contains(i)) {
			if (!quiet) {
				error("user does not exists");
			}
			return false;
		}
		if (ignores.contains(i)) {
			if (!quiet) {
				error("already ignoring user");
			}
			return false;
		}
		ignores.add(i);
		updateList();
		if (!quiet) {
			serverMessage("ignoring " + i);
		}
		return true;
	}
	
	/**
	 * Sends a text to the chat window. Parses the message to pick
	 * out emoticons.
	 * @param un	the name of the user sending the message
	 * @param message	the message to be sent
	 * @param whisper	indicates the message was a wisper and makes the 
	 *					message italic
	 */
	public void sendText(String un, String message, boolean whisper) {
		mainChat.sendText(un, message, whisper, m_textFontSize);
		m_lastMsg = un +" said "+"\'"+message+"\'";
	}
	
	/**
	 * Create a new connection to a server
	 */
	private void connect() {
		server = new ServerConnection(this);
	}
	
	/**
	 * sends a new message to the server
	 * @param message	the message to be sent
	 */
	private void sendChat(String message) {
		if (server != null) {
			server.writeObject(new SD_Chat(null, message));
			m_lastMsg = "you said "+"\'"+message+"\'";
		}
	}
	
	/**
	 * sends a whisper to the server
	 * @param message	the message to be sent
	 */
	private void sendWhisper(String to, String message) {
		if (server != null) {
			server.writeObject(new SD_Whisper(to, message));
		}
	}
	
	
	/**
	 * update how many users are online now
	 * (updated by server)
	 */ 
	public void updateUserNumber(int nUsers) {
		m_nUsers = nUsers;
		if(m_nUsers == 1)
			bottomText.setText("<html><body><font color=#FF0000 size=2><b>" +
				m_nUsers+ " online user" + "</b></font>" +"</body></html>");
		else
			bottomText.setText("<html><body><font color=#FF0000 size=2><b>" +
					m_nUsers+ " online users" + "</b></font>" +"</body></html>");
	}
	
	/**
	 * get the number of users online
	 * (called in client)
	 */ 
	public int getUserNumber() {
		return m_nUsers;
	}
	
	/**
	 * get the number of users online
	 * (called in client)
	 */ 
	public String getLastMsg() {
		return m_lastMsg;
	}
	
	/**
	 * sorts the user list and rebuilds the user list from 
	 * the sorted user vector,
	 */ 
	public void updateList() {
		Object[] tmp = users.toArray();
		Arrays.sort(tmp);
		userList.setListData(tmp);
	}
	
	/**
	 * adds a new user to the interal list of users
	 * @param un	the name of the user to be added
	 */
	public void userAdd(String un, boolean isParsed) {
		if (!users.contains(un)) {
			users.add(un);
			updateList();
			if (!un.equals(username) && showUserStatus)
				serverMessage(un + " has joined us.");
		}
	}
	
	/**
	 * removes a user from the user list
	 * @param un	the name of the user to be removed
	 */
	public void userDel(String un) {
		users.remove(users.indexOf(un));
		if (ignores.contains(un)) {
			ignores.remove(ignores.indexOf(un));
		}
		if (afks.contains(un)) {
			afks.remove(afks.indexOf(un));
		}
		if (admins.contains(un)) {
			admins.remove(admins.indexOf(un));
		}
		updateList();
		serverMessage(un + " has left.");
		privates.serverMessage(un, un + " has left");
	}
	
	/**
	 * changes the name of a user, updating list of admins,
	 * afks, ignoes, and master user list
	 * @param on	old username
	 * @param nn	new username
	 */
	public void rename(String on, String nn) {
		if (admins.contains(on)) {
			admins.remove(admins.indexOf(on));
			admins.add(nn);
		}
		if (afks.contains(on)) {
			afks.remove(afks.indexOf(on));
			afks.add(nn);
		}
		if (ignores.contains(on)) {
			ignores.remove(ignores.indexOf(on));
			ignores.add(nn);
		}
		users.remove(on);
		users.add(nn);
		updateList();
		//serverMessage(on + " renamed to " + nn);
	}
	
	/**
	 * Recieving method for a chat message
	 * @param un	the name of the user sending the chat
	 * @param message	the message that was sent
	 */
	public void recieveChat(String un, String message) {
		if (!ignores.contains(un)) {
			sendText(un, message, false);
			m_lastMsg = un +" said "+"\'"+message+"\'";
		}
	}
	
	/**
	 * Reciving method for a whisper
	 * @param un	the name of the user sending the whisper
	 * @param message	the message that was sent
	 */
	public void recieveWhisper(String un, String message) {
		if (!ignores.contains(un)) {
			sendText(un, message, true);
			m_lastMsg = un +" said "+"\'"+message+"\'";
		}
	}
	
	/**
	 * Recieving method for private
	 * @param un	the name of the user sending the message
	 * @param message	the message that was sent
	 */
	public void recievePrivate(String un, String message) {
		if (!ignores.contains(un)) {
			privates.recievePrivate(un, message, m_textFontSize);
		}
	}
	
	/**
	 * signifies an error and reports it to the user
	 * @param s	the error message
	 */
	public void error(String s) {
		mainChat.error(s);
	}
	
	/**
	 * A shortcut to be used when a message from the server (or any automated
	 * message) must ben sent to the client
	 * @param s	the message
	 */
	public void serverMessage(String s) {
		// commenting out to eliminate all server messages
		//		sendText("server", s, false);
	}
	
	/**
	 * cleans up a connection by removing all user from all
	 * tained lists
	 */
	public void close() {
		error("Connection to server was lost");
		admin = false;
		users.clear();
		afks.clear();
		ignores.clear();
		admins.clear();
		channels.clear();
		//cboChannels.removeAllItems();
		updateList();
	}
	
	/**
	 * used to manage the connection icons to signify connection and
	 * secure status
	 * @param b	true if connected
	 */
	public void setConnected(boolean b) {
		if (b) {
			conIcon.setIcon(conYes);
			conIcon.setToolTipText("Connected");
			secIcon.setIcon(secYes);
			secIcon.setToolTipText("Secure Connection");
			//butChannel.setEnabled(true);
		} else {
			conIcon.setIcon(conNo);
			conIcon.setToolTipText("Not Connected");
			secIcon.setIcon(secNo);
			secIcon.setToolTipText("Connection not Secured");
			//butChannel.setEnabled(false);
			//butCreate.setEnabled(false);
		}
	}
	
	/**
	 * sets this user to be an admin
	 */
	public void setAdmin() {
		admin = true;
		popup.add("kick user").addActionListener(myAction);
		if (chanAdmin) {
			//butCreate.setEnabled(true);
		}
	}
	
	/**
	 * creates a new channel, if the channel exists it is removed
	 * (this method doubles as a removeChannel)
	 * @param name	the name of the channel
	 */
	public void newChannel(String name, boolean pass) {
		if (channels.containsKey(name)) {
			channels.remove(name);
			//cboChannels.removeItem(name);
		} else {
			channels.put(name, new Boolean(pass));
			//cboChannels.addItem(name);
		}
	}
	
	public void sendPrivate(String name, String message) { 
		server.writeObject(new SD_Private(name, message + "\n"));
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		if(e.getActionCommand()=="Enlarge")
		{
			if(m_textFontSize<5)
				m_textFontSize++;
		}
		else
		{
			if(m_textFontSize>1)
				m_textFontSize--;
		}
		mainChat.changeFontSize(m_textFontSize);
	}
	
	public ChatPane GetPane()
	{
		return mainChat;
	}
	
	public JTextArea GetMessageArea()
	{
		return messageArea;
	}
	
	public JTextField GetMessageText()
	{
		return messageText;
	}
	
	public JList GetUsers()
	{
		return userList;
	}
	
	public JTextArea GetLastMsgArea()
	{
		return new JTextArea(getLastMsg());
	}
	
	public JPanel GetFigPanel(JComponent one, JComponent two, JComponent three)
	{		
//		int align = FlowLayout.CENTER;
		GridLayout gLay = new GridLayout(3,1);
		JPanel j = new JPanel(gLay);
		j.add(one);
		j.add(two);
		j.add(three);
		return j;
	}
	
	public void UpdatePanel(JPanel j)
	{
		j.add(GetMessageArea(), 1);
		j.add(GetMessageText(), 2);
		j.add(GetUsers(), 3);
	}
	
	public String GetHistory()
	{
		return history.toString();
	}
	
	public void show()
	{
		super.setVisible(true);
	}
	public void hide()
	{
		super.setVisible(false);
	}
	public EEGLABChat GetInstance()
	{
		return this;
	}

}

